diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/class-wp-theme-install-list-table.php ./wordpress-3.4/wp-admin/includes/class-wp-theme-install-list-table.php
*** ./wordpress-3.3.2/wp-admin/includes/class-wp-theme-install-list-table.php	2011-09-14 23:26:26.000000000 -0500
--- ./wordpress-3.4/wp-admin/includes/class-wp-theme-install-list-table.php	2012-06-06 16:45:17.000000000 -0500
***************
*** 7,25 ****
   * @since 3.1.0
   * @access private
   */
! class WP_Theme_Install_List_Table extends WP_List_Table {
  
  	function ajax_user_can() {
! 		return current_user_can('install_themes');
  	}
  
  	function prepare_items() {
  		include( ABSPATH . 'wp-admin/includes/theme-install.php' );
  
! 		global $tabs, $tab, $paged, $type, $term, $theme_field_defaults;
! 
  		wp_reset_vars( array( 'tab' ) );
  
  		$paged = $this->get_pagenum();
  
  		$per_page = 36;
--- 7,36 ----
   * @since 3.1.0
   * @access private
   */
! class WP_Theme_Install_List_Table extends WP_Themes_List_Table {
! 
! 	var $features = array();
  
  	function ajax_user_can() {
! 		return current_user_can( 'install_themes' );
  	}
  
  	function prepare_items() {
  		include( ABSPATH . 'wp-admin/includes/theme-install.php' );
  
! 		global $tabs, $tab, $paged, $type, $theme_field_defaults;
  		wp_reset_vars( array( 'tab' ) );
  
+ 		$search_terms = array();
+ 		$search_string = '';
+ 		if ( ! empty( $_REQUEST['s'] ) ){
+ 			$search_string = strtolower( stripslashes( $_REQUEST['s'] ) );
+ 			$search_terms = array_unique( array_filter( array_map( 'trim', explode( ',', $search_string ) ) ) );
+ 		}
+ 
+ 		if ( ! empty( $_REQUEST['features'] ) )
+ 			$this->features = $_REQUEST['features'];
+ 
  		$paged = $this->get_pagenum();
  
  		$per_page = 36;
***************
*** 48,81 ****
  
  		switch ( $tab ) {
  			case 'search':
! 				$type = isset( $_REQUEST['type'] ) ? stripslashes( $_REQUEST['type'] ) : '';
! 				$term = isset( $_REQUEST['s'] ) ? stripslashes( $_REQUEST['s'] ) : '';
! 
  				switch ( $type ) {
  					case 'tag':
! 						$terms = explode( ',', $term );
! 						$terms = array_map( 'trim', $terms );
! 						$terms = array_map( 'sanitize_title_with_dashes', $terms );
! 						$args['tag'] = $terms;
  						break;
  					case 'term':
! 						$args['search'] = $term;
  						break;
  					case 'author':
! 						$args['author'] = $term;
  						break;
  				}
  
! 				if ( !empty( $_POST['features'] ) ) {
! 					$terms = $_POST['features'];
! 					$terms = array_map( 'trim', $terms );
! 					$terms = array_map( 'sanitize_title_with_dashes', $terms );
! 					$args['tag'] = $terms;
! 					$_REQUEST['s'] = implode( ',', $terms );
  					$_REQUEST['type'] = 'tag';
  				}
  
! 				add_action( 'install_themes_table_header', 'install_theme_search_form' );
  				break;
  
  			case 'featured':
--- 59,84 ----
  
  		switch ( $tab ) {
  			case 'search':
! 				$type = isset( $_REQUEST['type'] ) ? stripslashes( $_REQUEST['type'] ) : 'term';
  				switch ( $type ) {
  					case 'tag':
! 						$args['tag'] = array_map( 'sanitize_key', $search_terms );
  						break;
  					case 'term':
! 						$args['search'] = $search_string;
  						break;
  					case 'author':
! 						$args['author'] = $search_string;
  						break;
  				}
  
! 				if ( ! empty( $this->features ) ) {
! 					$args['tag'] = $this->features;
! 					$_REQUEST['s'] = implode( ',', $this->features );
  					$_REQUEST['type'] = 'tag';
  				}
  
! 				add_action( 'install_themes_table_header', 'install_theme_search_form', 10, 0 );
  				break;
  
  			case 'featured':
***************
*** 89,95 ****
  				$args = false;
  		}
  
! 		if ( !$args )
  			return;
  
  		$api = themes_api( 'query_themes', $args );
--- 92,98 ----
  				$args = false;
  		}
  
! 		if ( ! $args )
  			return;
  
  		$api = themes_api( 'query_themes', $args );
***************
*** 102,107 ****
--- 105,111 ----
  		$this->set_pagination_args( array(
  			'total_items' => $api->info['results'],
  			'per_page' => $per_page,
+ 			'infinite_scroll' => true,
  		) );
  	}
  
***************
*** 122,134 ****
  		return $display_tabs;
  	}
  
- 	function get_columns() {
- 		return array();
- 	}
- 
  	function display() {
! 
! 		// wp_nonce_field( "fetch-list-" . get_class( $this ), '_ajax_fetch_list_nonce' );
  ?>
  		<div class="tablenav top themes">
  			<div class="alignleft actions">
--- 126,133 ----
  		return $display_tabs;
  	}
  
  	function display() {
! 		wp_nonce_field( "fetch-list-" . get_class( $this ), '_ajax_fetch_list_nonce' );
  ?>
  		<div class="tablenav top themes">
  			<div class="alignleft actions">
***************
*** 143,169 ****
  			<?php $this->display_rows_or_placeholder(); ?>
  		</div>
  
! 		<div class="tablenav bottom themes">
! 			<?php $this->pagination( 'bottom' ); ?>
! 			<img src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" class="ajax-loading list-ajax-loading" alt="" />
! 			<br class="clear" />
! 		</div>
! <?php
  	}
  
  	function display_rows() {
  		$themes = $this->items;
! 		$theme_names = array_keys( $themes );
! 
! 		foreach ( $theme_names as $theme_name ) {
! 				$class = array( 'available-theme' );
  				?>
! 				<div class="<?php echo join( ' ', $class ); ?>"><?php
! 					if ( isset( $themes[$theme_name] ) )
! 						display_theme( $themes[$theme_name] );
  				?></div>
  		<?php } // end foreach $theme_names
  	}
- }
  
! ?>
--- 142,395 ----
  			<?php $this->display_rows_or_placeholder(); ?>
  		</div>
  
! 		<?php
! 		parent::tablenav( 'bottom' );
  	}
  
  	function display_rows() {
  		$themes = $this->items;
! 		foreach ( $themes as $theme ) {
  				?>
! 				<div class="available-theme installable-theme"><?php
! 					$this->single_row( $theme );
  				?></div>
  		<?php } // end foreach $theme_names
+ 
+ 		$this->theme_installer();
  	}
  
! 	/*
! 	 * Prints a theme from the WordPress.org API.
! 	 *
! 	 * @param object $theme An object that contains theme data returned by the WordPress.org API.
! 	 *
! 	 * Example theme data:
! 	 *   object(stdClass)[59]
! 	 *     public 'name' => string 'Magazine Basic' (length=14)
! 	 *     public 'slug' => string 'magazine-basic' (length=14)
! 	 *     public 'version' => string '1.1' (length=3)
! 	 *     public 'author' => string 'tinkerpriest' (length=12)
! 	 *     public 'preview_url' => string 'http://wp-themes.com/?magazine-basic' (length=36)
! 	 *     public 'screenshot_url' => string 'http://wp-themes.com/wp-content/themes/magazine-basic/screenshot.png' (length=68)
! 	 *     public 'rating' => float 80
! 	 *     public 'num_ratings' => int 1
! 	 *     public 'homepage' => string 'http://wordpress.org/extend/themes/magazine-basic' (length=49)
! 	 *     public 'description' => string 'A basic magazine style layout with a fully customizable layout through a backend interface. Designed by <a href="http://bavotasan.com">c.bavota</a> of <a href="http://tinkerpriestmedia.com">Tinker Priest Media</a>.' (length=214)
! 	 *     public 'download_link' => string 'http://wordpress.org/extend/themes/download/magazine-basic.1.1.zip' (length=66)
! 	 */
! 	function single_row( $theme ) {
! 		global $themes_allowedtags;
! 
! 		if ( empty( $theme ) )
! 			return;
! 
! 		$name   = wp_kses( $theme->name,   $themes_allowedtags );
! 		$author = wp_kses( $theme->author, $themes_allowedtags );
! 
! 		$preview_title = sprintf( __('Preview &#8220;%s&#8221;'), $name );
! 		$preview_url   = add_query_arg( array(
! 			'tab'   => 'theme-information',
! 			'theme' => $theme->slug,
! 		) );
! 
! 		$actions = array();
! 
! 		$install_url = add_query_arg( array(
! 			'action' => 'install-theme',
! 			'theme'  => $theme->slug,
! 		), self_admin_url( 'update.php' ) );
! 
! 		$update_url = add_query_arg( array(
! 			'action' => 'upgrade-theme',
! 			'theme'  => $theme->slug,
! 		), self_admin_url( 'update.php' ) );
! 
! 		$status = $this->_get_theme_status( $theme );
! 
! 		switch ( $status ) {
! 			default:
! 			case 'install':
! 				$actions[] = '<a class="install-now" href="' . esc_url( wp_nonce_url( $install_url, 'install-theme_' . $theme->slug ) ) . '" title="' . esc_attr( sprintf( __( 'Install %s' ), $name ) ) . '">' . __( 'Install Now' ) . '</a>';
! 				break;
! 			case 'update_available':
! 				$actions[] = '<a class="install-now" href="' . esc_url( wp_nonce_url( $update_url, 'upgrade-theme_' . $theme->slug ) ) . '" title="' . esc_attr( sprintf( __( 'Update to version %s' ), $theme->version ) ) . '">' . __( 'Update' ) . '</a>';
! 				break;
! 			case 'newer_installed':
! 			case 'latest_installed':
! 				$actions[] = '<span class="install-now" title="' . esc_attr__( 'This theme is already installed and is up to date' ) . '">' . _x( 'Installed', 'theme' ) . '</span>';
! 				break;
! 		}
! 
! 		$actions[] = '<a class="install-theme-preview" href="' . esc_url( $preview_url ) . '" title="' . esc_attr( sprintf( __( 'Preview %s' ), $name ) ) . '">' . __( 'Preview' ) . '</a>';
! 
! 		$actions = apply_filters( 'theme_install_actions', $actions, $theme );
! 
! 		?>
! 		<a class="screenshot install-theme-preview" href="<?php echo esc_url( $preview_url ); ?>" title="<?php echo esc_attr( $preview_title ); ?>">
! 			<img src='<?php echo esc_url( $theme->screenshot_url ); ?>' width='150' />
! 		</a>
! 
! 		<h3><?php echo $name; ?></h3>
! 		<div class="theme-author"><?php printf( __( 'By %s' ), $author ); ?></div>
! 
! 		<div class="action-links">
! 			<ul>
! 				<?php foreach ( $actions as $action ): ?>
! 					<li><?php echo $action; ?></li>
! 				<?php endforeach; ?>
! 				<li class="hide-if-no-js"><a href="#" class="theme-detail" tabindex='4'><?php _e('Details') ?></a></li>
! 			</ul>
! 		</div>
! 
! 		<?php
! 		$this->install_theme_info( $theme );
! 	}
! 
! 	/*
! 	 * Prints the wrapper for the theme installer.
! 	 */
! 	function theme_installer() {
! 		?>
! 		<div id="theme-installer" class="wp-full-overlay expanded">
! 			<div class="wp-full-overlay-sidebar">
! 				<div class="wp-full-overlay-header">
! 					<a href="#" class="close-full-overlay"><?php _e( '&larr; Close' ); ?></a>
! 				</div>
! 				<div class="wp-full-overlay-sidebar-content">
! 					<div class="install-theme-info"></div>
! 				</div>
! 				<div class="wp-full-overlay-footer">
! 					<a href="#" class="collapse-sidebar button-secondary" title="<?php esc_attr_e('Collapse Sidebar'); ?>">
! 						<span class="collapse-sidebar-label"><?php _e('Collapse'); ?></span>
! 						<span class="collapse-sidebar-arrow"></span>
! 					</a>
! 				</div>
! 			</div>
! 			<div class="wp-full-overlay-main"></div>
! 		</div>
! 		<?php
! 	}
! 
! 	/*
! 	 * Prints the wrapper for the theme installer with a provided theme's data.
! 	 * Used to make the theme installer work for no-js.
! 	 *
! 	 * @param object $theme - A WordPress.org Theme API object.
! 	 */
! 	function theme_installer_single( $theme ) {
! 		?>
! 		<div id="theme-installer" class="wp-full-overlay single-theme">
! 			<div class="wp-full-overlay-sidebar">
! 				<?php $this->install_theme_info( $theme ); ?>
! 			</div>
! 			<div class="wp-full-overlay-main">
! 				<iframe src="<?php echo esc_url( $theme->preview_url ); ?>"></iframe>
! 			</div>
! 		</div>
! 		<?php
! 	}
! 
! 	/*
! 	 * Prints the info for a theme (to be used in the theme installer modal).
! 	 *
! 	 * @param object $theme - A WordPress.org Theme API object.
! 	 */
! 	function install_theme_info( $theme ) {
! 		global $themes_allowedtags;
! 
! 		if ( empty( $theme ) )
! 			return;
! 
! 		$name   = wp_kses( $theme->name,   $themes_allowedtags );
! 		$author = wp_kses( $theme->author, $themes_allowedtags );
! 
! 		$num_ratings = sprintf( _n( '(based on %s rating)', '(based on %s ratings)', $theme->num_ratings ), number_format_i18n( $theme->num_ratings ) );
! 
! 		$install_url = add_query_arg( array(
! 			'action' => 'install-theme',
! 			'theme'  => $theme->slug,
! 		), self_admin_url( 'update.php' ) );
! 
! 		$update_url = add_query_arg( array(
! 			'action' => 'upgrade-theme',
! 			'theme'  => $theme->slug,
! 		), self_admin_url( 'update.php' ) );
! 
! 		$status = $this->_get_theme_status( $theme );
! 
! 		?>
! 		<div class="install-theme-info"><?php
! 			switch ( $status ) {
! 				default:
! 				case 'install':
! 					echo '<a class="theme-install button-primary" href="' . esc_url( wp_nonce_url( $install_url, 'install-theme_' . $theme->slug ) ) . '">' . __( 'Install' ) . '</a>';
! 					break;
! 				case 'update_available':
! 					echo '<a class="theme-install button-primary" href="' . esc_url( wp_nonce_url( $update_url, 'upgrade-theme_' . $theme->slug ) ) . '" title="' . esc_attr( sprintf( __( 'Update to version %s' ), $theme->version ) ) . '">' . __( 'Update' ) . '</a>';
! 					break;
! 				case 'newer_installed':
! 				case 'latest_installed':
! 					echo '<span class="theme-install" title="' . esc_attr__( 'This theme is already installed and is up to date' ) . '">' . _x( 'Installed', 'theme' ) . '</span>';
! 					break;
! 			} ?>
! 			<h3 class="theme-name"><?php echo $name; ?></h3>
! 			<span class="theme-by"><?php printf( __( 'By %s' ), $author ); ?></span>
! 			<?php if ( isset( $theme->screenshot_url ) ): ?>
! 				<img class="theme-screenshot" src="<?php echo esc_url( $theme->screenshot_url ); ?>" />
! 			<?php endif; ?>
! 			<div class="theme-details">
! 				<div class="star-holder" title="<?php echo esc_attr( $num_ratings ); ?>">
! 					<div class="star-rating" style="width:<?php echo esc_attr( intval( $theme->rating ) . 'px' ); ?>;"></div>
! 				</div>
! 				<div class="theme-version">
! 					<strong><?php _e('Version:') ?> </strong>
! 					<?php echo wp_kses( $theme->version, $themes_allowedtags ); ?>
! 				</div>
! 				<div class="theme-description">
! 					<?php echo wp_kses( $theme->description, $themes_allowedtags ); ?>
! 				</div>
! 			</div>
! 			<input class="theme-preview-url" type="hidden" value="<?php echo esc_url( $theme->preview_url ); ?>" />
! 		</div>
! 		<?php
! 	}
! 
! 	/**
! 	 * Send required variables to JavaScript land
! 	 *
! 	 * @since 3.4
! 	 * @access private
! 	 *
! 	 * @uses $tab Global; current tab within Themes->Install screen
! 	 * @uses $type Global; type of search.
! 	 */
! 	function _js_vars() {
! 		global $tab, $type;
! 		parent::_js_vars( compact( 'tab', 'type' ) );
! 	}
! 
! 	/**
! 	 * Check to see if the theme is already installed.
! 	 *
! 	 * @since 3.4
! 	 * @access private
! 	 *
! 	 * @param object $theme - A WordPress.org Theme API object.
! 	 * @return string Theme status.
! 	 */
! 	private function _get_theme_status( $theme ) {
! 		$status = 'install';
! 
! 		$installed_theme = wp_get_theme( $theme->slug );
! 		if ( $installed_theme->exists() ) {
! 			if ( version_compare( $installed_theme->get('Version'), $theme->version, '=' ) )
! 				$status = 'latest_installed';
! 			elseif ( version_compare( $installed_theme->get('Version'), $theme->version, '>' ) )
! 				$status = 'newer_installed';
! 			else
! 				$status = 'update_available';
! 		}
! 
! 		return $status;
! 	}
! }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/class-wp-themes-list-table.php ./wordpress-3.4/wp-admin/includes/class-wp-themes-list-table.php
*** ./wordpress-3.3.2/wp-admin/includes/class-wp-themes-list-table.php	2011-09-14 23:26:26.000000000 -0500
--- ./wordpress-3.4/wp-admin/includes/class-wp-themes-list-table.php	2012-06-06 15:34:24.000000000 -0500
***************
*** 9,67 ****
   */
  class WP_Themes_List_Table extends WP_List_Table {
  
! 	var $search = array();
  	var $features = array();
  
  	function ajax_user_can() {
  		// Do not check edit_theme_options here. AJAX calls for available themes require switch_themes.
! 		return current_user_can('switch_themes');
  	}
  
  	function prepare_items() {
! 		global $ct;
  
! 		$ct = current_theme_info();
! 
! 		$themes = get_allowed_themes();
! 
! 		if ( ! empty( $_REQUEST['s'] ) ) {
! 			$search = strtolower( stripslashes( $_REQUEST['s'] ) );
! 			$this->search = array_merge( $this->search, array_filter( array_map( 'trim', explode( ',', $search ) ) ) );
! 			$this->search = array_unique( $this->search );
! 		}
  
! 		if ( !empty( $_REQUEST['features'] ) ) {
  			$this->features = $_REQUEST['features'];
- 			$this->features = array_map( 'trim', $this->features );
- 			$this->features = array_map( 'sanitize_title_with_dashes', $this->features );
- 			$this->features = array_unique( $this->features );
- 		}
  
! 		if ( $this->search || $this->features ) {
  			foreach ( $themes as $key => $theme ) {
! 				if ( !$this->search_theme( $theme ) )
  					unset( $themes[ $key ] );
  			}
  		}
  
! 		unset( $themes[$ct->name] );
! 		uksort( $themes, "strnatcasecmp" );
  
! 		$per_page = 24;
  		$page = $this->get_pagenum();
  
  		$start = ( $page - 1 ) * $per_page;
  
! 		$this->items = array_slice( $themes, $start, $per_page );
  
  		$this->set_pagination_args( array(
  			'total_items' => count( $themes ),
  			'per_page' => $per_page,
  		) );
  	}
  
  	function no_items() {
! 		if ( $this->search || $this->features ) {
  			_e( 'No items found.' );
  			return;
  		}
--- 9,63 ----
   */
  class WP_Themes_List_Table extends WP_List_Table {
  
! 	protected $search_terms = array();
  	var $features = array();
  
+ 	function __construct() {
+ 		parent::__construct( array(
+ 			'ajax' => true,
+ 		) );
+ 	}
+ 
  	function ajax_user_can() {
  		// Do not check edit_theme_options here. AJAX calls for available themes require switch_themes.
! 		return current_user_can( 'switch_themes' );
  	}
  
  	function prepare_items() {
! 		$themes = wp_get_themes( array( 'allowed' => true ) );
  
! 		if ( ! empty( $_REQUEST['s'] ) )
! 			$this->search_terms = array_unique( array_filter( array_map( 'trim', explode( ',', strtolower( stripslashes( $_REQUEST['s'] ) ) ) ) ) );
  
! 		if ( ! empty( $_REQUEST['features'] ) )
  			$this->features = $_REQUEST['features'];
  
! 		if ( $this->search_terms || $this->features ) {
  			foreach ( $themes as $key => $theme ) {
! 				if ( ! $this->search_theme( $theme ) )
  					unset( $themes[ $key ] );
  			}
  		}
  
! 		unset( $themes[ get_option( 'stylesheet' ) ] );
! 		WP_Theme::sort_by_name( $themes );
  
! 		$per_page = 999;
  		$page = $this->get_pagenum();
  
  		$start = ( $page - 1 ) * $per_page;
  
! 		$this->items = array_slice( $themes, $start, $per_page, true );
  
  		$this->set_pagination_args( array(
  			'total_items' => count( $themes ),
  			'per_page' => $per_page,
+ 			'infinite_scroll' => true,
  		) );
  	}
  
  	function no_items() {
! 		if ( $this->search_terms || $this->features ) {
  			_e( 'No items found.' );
  			return;
  		}
***************
*** 101,107 ****
  	}
  
  	function display() {
! 		// wp_nonce_field( "fetch-list-" . get_class( $this ), '_ajax_fetch_list_nonce' );
  ?>
  		<?php $this->tablenav( 'top' ); ?>
  
--- 97,103 ----
  	}
  
  	function display() {
! 		wp_nonce_field( "fetch-list-" . get_class( $this ), '_ajax_fetch_list_nonce' );
  ?>
  		<?php $this->tablenav( 'top' ); ?>
  
***************
*** 119,222 ****
  
  	function display_rows() {
  		$themes = $this->items;
- 		$theme_names = array_keys( $themes );
- 		natcasesort( $theme_names );
  
! 	foreach ( $theme_names as $theme_name ) {
! 		$class = array( 'available-theme' );
! 	?>
! 	<div class="<?php echo join( ' ', $class ); ?>">
! 	<?php if ( !empty( $theme_name ) ) :
! 	$template = $themes[$theme_name]['Template'];
! 	$stylesheet = $themes[$theme_name]['Stylesheet'];
! 	$title = $themes[$theme_name]['Title'];
! 	$version = $themes[$theme_name]['Version'];
! 	$description = $themes[$theme_name]['Description'];
! 	$author = $themes[$theme_name]['Author'];
! 	$screenshot = $themes[$theme_name]['Screenshot'];
! 	$stylesheet_dir = $themes[$theme_name]['Stylesheet Dir'];
! 	$template_dir = $themes[$theme_name]['Template Dir'];
! 	$parent_theme = $themes[$theme_name]['Parent Theme'];
! 	$theme_root = $themes[$theme_name]['Theme Root'];
! 	$theme_root_uri = $themes[$theme_name]['Theme Root URI'];
! 	$preview_link = esc_url( get_option( 'home' ) . '/' );
! 	if ( is_ssl() )
! 		$preview_link = str_replace( 'http://', 'https://', $preview_link );
! 	$preview_link = htmlspecialchars( add_query_arg( array( 'preview' => 1, 'template' => $template, 'stylesheet' => $stylesheet, 'preview_iframe' => true, 'TB_iframe' => 'true' ), $preview_link ) );
! 	$preview_text = esc_attr( sprintf( __( 'Preview of &#8220;%s&#8221;' ), $title ) );
! 	$tags = $themes[$theme_name]['Tags'];
! 	$thickbox_class = 'thickbox thickbox-preview';
! 	$activate_link = wp_nonce_url( "themes.php?action=activate&amp;template=".urlencode( $template )."&amp;stylesheet=".urlencode( $stylesheet ), 'switch-theme_' . $template );
! 	$activate_text = esc_attr( sprintf( __( 'Activate &#8220;%s&#8221;' ), $title ) );
! 	$actions = array();
! 	$actions[] = '<a href="' . $activate_link .  '" class="activatelink" title="' . $activate_text . '">' . __( 'Activate' ) . '</a>';
! 	$actions[] = '<a href="' . $preview_link . '" class="thickbox thickbox-preview" title="' . esc_attr( sprintf( __( 'Preview &#8220;%s&#8221;' ), $theme_name ) ) . '">' . __( 'Preview' ) . '</a>';
! 	if ( ! is_multisite() && current_user_can( 'delete_themes' ) )
! 		$actions[] = '<a class="submitdelete deletion" href="' . wp_nonce_url( "themes.php?action=delete&amp;template=$stylesheet", 'delete-theme_' . $stylesheet ) . '" onclick="' . "return confirm( '" . esc_js( sprintf( __( "You are about to delete this theme '%s'\n  'Cancel' to stop, 'OK' to delete." ), $theme_name ) ) . "' );" . '">' . __( 'Delete' ) . '</a>';
! 	$actions = apply_filters( 'theme_action_links', $actions, $themes[$theme_name] );
  
! 	$actions = implode ( ' | ', $actions );
! ?>
! 		<a href="<?php echo $preview_link; ?>" class="<?php echo $thickbox_class; ?> screenshot">
! <?php if ( $screenshot ) : ?>
! 			<img src="<?php echo $theme_root_uri . '/' . $stylesheet . '/' . $screenshot; ?>" alt="" />
! <?php endif; ?>
! 		</a>
! <h3><?php
! 	/* translators: 1: theme title, 2: theme version, 3: theme author */
! 	printf( __( '%1$s %2$s by %3$s' ), $title, $version, $author ) ; ?></h3>
! <p class="description"><?php echo $description; ?></p>
! <span class='action-links'><?php echo $actions ?></span>
! 	<?php if ( current_user_can( 'edit_themes' ) && $parent_theme ) {
! 	/* translators: 1: theme title, 2:  template dir, 3: stylesheet_dir, 4: theme title, 5: parent_theme */ ?>
! 	<p><?php printf( __( 'The template files are located in <code>%2$s</code>. The stylesheet files are located in <code>%3$s</code>. <strong>%4$s</strong> uses templates from <strong>%5$s</strong>. Changes made to the templates will affect both themes.' ), $title, str_replace( WP_CONTENT_DIR, '', $template_dir ), str_replace( WP_CONTENT_DIR, '', $stylesheet_dir ), $title, $parent_theme ); ?></p>
! <?php } else { ?>
! 	<p><?php printf( __( 'All of this theme&#8217;s files are located in <code>%2$s</code>.' ), $title, str_replace( WP_CONTENT_DIR, '', $template_dir ), str_replace( WP_CONTENT_DIR, '', $stylesheet_dir ) ); ?></p>
! <?php } ?>
! <?php if ( $tags ) : ?>
! <p><?php _e( 'Tags:' ); ?> <?php echo join( ', ', $tags ); ?></p>
! <?php endif; ?>
! 		<?php theme_update_available( $themes[$theme_name] ); ?>
! <?php endif; // end if not empty theme_name ?>
! 	</div>
! <?php } // end foreach $theme_names
  	}
  
  	function search_theme( $theme ) {
! 		$matched = 0;
  
  		// Match all phrases
! 		if ( count( $this->search ) > 0 ) {
! 			foreach ( $this->search as $word ) {
! 				$matched = 0;
! 
! 				// In a tag?
! 				if ( in_array( $word, array_map( 'sanitize_title_with_dashes', $theme['Tags'] ) ) )
! 					$matched = 1;
! 
! 				// In one of the fields?
! 				foreach ( array( 'Name', 'Title', 'Description', 'Author', 'Template', 'Stylesheet' ) AS $field ) {
! 					if ( stripos( $theme[$field], $word ) !== false )
! 						$matched++;
! 				}
! 
! 				if ( $matched == 0 )
! 					return false;
  			}
- 		}
  
! 		// Now search the features
! 		if ( count( $this->features ) > 0 ) {
! 			foreach ( $this->features as $word ) {
! 				// In a tag?
! 				if ( !in_array( $word, array_map( 'sanitize_title_with_dashes', $theme['Tags'] ) ) )
! 					return false;
! 			}
  		}
  
- 		// Only get here if each word exists in the tags or one of the fields
  		return true;
  	}
- }
  
! ?>
--- 115,256 ----
  
  	function display_rows() {
  		$themes = $this->items;
  
! 		foreach ( $themes as $theme ):
! 			?><div class="available-theme"><?php
  
! 			$template   = $theme->get_template();
! 			$stylesheet = $theme->get_stylesheet();
! 			$title      = $theme->display('Name');
! 			$version    = $theme->display('Version');
! 			$author     = $theme->display('Author');
! 
! 			$activate_link = wp_nonce_url( "themes.php?action=activate&amp;template=" . urlencode( $template ) . "&amp;stylesheet=" . urlencode( $stylesheet ), 'switch-theme_' . $stylesheet );
! 
! 			$preview_link = esc_url( add_query_arg(
! 				array( 'preview' => 1, 'template' => $template, 'stylesheet' => $stylesheet, 'preview_iframe' => true, 'TB_iframe' => 'true' ),
! 				home_url( '/' ) ) );
! 
! 			$actions = array();
! 			$actions['activate'] = '<a href="' . $activate_link . '" class="activatelink" title="'
! 				. esc_attr( sprintf( __( 'Activate &#8220;%s&#8221;' ), $title ) ) . '">' . __( 'Activate' ) . '</a>';
! 
! 			$actions['preview'] = '<a href="' . $preview_link . '" class="hide-if-customize" title="'
! 				. esc_attr( sprintf( __( 'Preview &#8220;%s&#8221;' ), $title ) ) . '">' . __( 'Preview' ) . '</a>';
! 
! 			if ( current_user_can( 'edit_theme_options' ) )
! 				$actions['preview'] .= '<a href="' . wp_customize_url( $stylesheet ) . '" class="load-customize hide-if-no-customize">'
! 					. __( 'Live Preview' ) . '</a>';
! 
! 			if ( ! is_multisite() && current_user_can( 'delete_themes' ) )
! 				$actions['delete'] = '<a class="submitdelete deletion" href="' . wp_nonce_url( "themes.php?action=delete&amp;stylesheet=$stylesheet", 'delete-theme_' . $stylesheet )
! 					. '" onclick="' . "return confirm( '" . esc_js( sprintf( __( "You are about to delete this theme '%s'\n  'Cancel' to stop, 'OK' to delete." ), $title ) )
! 					. "' );" . '">' . __( 'Delete' ) . '</a>';
! 
! 			$actions       = apply_filters( 'theme_action_links', $actions, $theme );
! 			$delete_action = isset( $actions['delete'] ) ? '<div class="delete-theme">' . $actions['delete'] . '</div>' : '';
! 			unset( $actions['delete'] );
! 
! 			?>
! 
! 			<a href="<?php echo $preview_link; ?>" class="screenshot hide-if-customize">
! 				<?php if ( $screenshot = $theme->get_screenshot() ) : ?>
! 					<img src="<?php echo esc_url( $screenshot ); ?>" alt="" />
! 				<?php endif; ?>
! 			</a>
! 			<a href="<?php echo wp_customize_url( $stylesheet ); ?>" class="screenshot load-customize hide-if-no-customize">
! 				<?php if ( $screenshot = $theme->get_screenshot() ) : ?>
! 					<img src="<?php echo esc_url( $screenshot ); ?>" alt="" />
! 				<?php endif; ?>
! 			</a>
! 
! 			<h3><?php echo $title; ?></h3>
! 			<div class="theme-author"><?php printf( __( 'By %s' ), $author ); ?></div>
! 			<div class="action-links">
! 				<ul>
! 					<?php foreach ( $actions as $action ): ?>
! 						<li><?php echo $action; ?></li>
! 					<?php endforeach; ?>
! 					<li class="hide-if-no-js"><a href="#" class="theme-detail" tabindex='4'><?php _e('Details') ?></a></li>
! 				</ul>
! 				<?php echo $delete_action; ?>
! 
! 				<?php theme_update_available( $theme ); ?>
! 			</div>
! 
! 			<div class="themedetaildiv hide-if-js">
! 				<p><strong><?php _e('Version: '); ?></strong><?php echo $version; ?></p>
! 				<p><?php echo $theme->display('Description'); ?></p>
! 				<?php if ( current_user_can( 'edit_themes' ) && $theme->parent() ) :
! 					/* translators: 1: theme title, 2:  template dir, 3: stylesheet_dir, 4: theme title, 5: parent_theme */ ?>
! 					<p><?php printf( __( 'The template files are located in <code>%2$s</code>. The stylesheet files are located in <code>%3$s</code>. <strong>%4$s</strong> uses templates from <strong>%5$s</strong>. Changes made to the templates will affect both themes.' ),
! 						$title, str_replace( WP_CONTENT_DIR, '', $theme->get_template_directory() ), str_replace( WP_CONTENT_DIR, '', $theme->get_stylesheet_directory() ), $title, $theme->parent()->display('Name') ); ?></p>
! 				<?php else :
! 						/* translators: 1: theme title, 2:  template dir, 3: stylesheet_dir */ ?>
! 					<p><?php printf( __( 'All of this theme&#8217;s files are located in <code>%2$s</code>.' ),
! 						$title, str_replace( WP_CONTENT_DIR, '', $theme->get_template_directory() ), str_replace( WP_CONTENT_DIR, '', $theme->get_stylesheet_directory() ) ); ?></p>
! 				<?php endif; ?>
! 			</div>
! 
! 			</div>
! 		<?php
! 		endforeach;
  	}
  
  	function search_theme( $theme ) {
! 		// Search the features
! 		foreach ( $this->features as $word ) {
! 			if ( ! in_array( $word, $theme->get('Tags') ) )
! 				return false;
! 		}
  
  		// Match all phrases
! 		foreach ( $this->search_terms as $word ) {
! 			if ( in_array( $word, $theme->get('Tags') ) )
! 				continue;
! 
! 			foreach ( array( 'Name', 'Description', 'Author', 'AuthorURI' ) as $header ) {
! 				// Don't mark up; Do translate.
! 				if ( false !== stripos( $theme->display( $header, false, true ), $word ) )
! 					continue 2;
  			}
  
! 			if ( false !== stripos( $theme->get_stylesheet(), $word ) )
! 				continue;
! 
! 			if ( false !== stripos( $theme->get_template(), $word ) )
! 				continue;
! 
! 			return false;
  		}
  
  		return true;
  	}
  
! 	/**
! 	 * Send required variables to JavaScript land
! 	 *
! 	 * @since 3.4
! 	 * @access private
! 	 *
! 	 * @uses $this->features Array of all feature search terms.
! 	 * @uses get_pagenum()
! 	 * @uses _pagination_args['total_pages']
! 	 */
! 	 function _js_vars( $extra_args = array() ) {
! 		$search_string = isset( $_REQUEST['s'] ) ? esc_attr( stripslashes( $_REQUEST['s'] ) ) : '';
! 
! 		$args = array(
! 			'search' => $search_string,
! 			'features' => $this->features,
! 			'paged' => $this->get_pagenum(),
! 			'total_pages' => ! empty( $this->_pagination_args['total_pages'] ) ? $this->_pagination_args['total_pages'] : 1,
! 		);
! 
! 		if ( is_array( $extra_args ) )
! 			$args = array_merge( $args, $extra_args );
! 
! 		printf( "<script type='text/javascript'>var theme_list_args = %s;</script>\n", json_encode( $args ) );
! 		parent::_js_vars();
! 	}
! }
